#
# This is the server logic of a Shiny web application. You can run the 
# application by clicking 'Run App' above.
#
# Find out more about building applications with Shiny here:
# 
#    http://shiny.rstudio.com/
#
library(googleVis)
library(shinyBS)
library(pdftools)
library(stringr)
library(stringi)
library(tm)
library(ggplot2)
library(dplyr)
library(wordcloud)
require(shiny)
require(RCurl)
require(XML)
library(readxl)
require(XLConnect)
library(DT)
library(knitr)
library(xlsx)
library(dplyr)
library(readxl)
library(ggplot2)
library(alr3)
library(dplyr)
library(knitr)

library(vembedr)
library(shiny)
library(devtools)
devtools::install_github("ngramr", "seancarmody")
library(ngramr)
library(ggplot2)
library(lubridate)
library(nlme)
library(plotly)
library(shinydashboard)
library(shiny)

# Define server logic required to draw a histogram
shinyServer(function(input, output, session) {
  options(shiny.maxRequestSize=800*1024^2) 
  
  create_userInfo <- reactive({
    
    query <- parseQueryString(session$clientData$url_search)
    
    # parse URL for status
    user_status <- "Online"
    
    if ( "status" %in% names(query) ) {
      
      if (query[["status"]] == "away") {
        
        user_status = "Away"
        
      } else if (query[["status"]] == "offline") {
        
        user_status = "Offline"
        
      }
      
    }
    
    # set default userInfo
    head_user <-ygdashboard::dashboardUser(
      name = "Aurélien Nicosia",
      image = "moi.png",
      description = "Statistician",
      sub_description = "Member since Aug. 2015",
      stat1 = "100 Posts",
      stat2 = "2048 Followers",
      stat3 = "1024 Following",
      btn1 = "Profile",
      btn2 = "Sign Out"
    )
    
    side_user <-  ygdashboard::sidebarUserPanel(
      name = "Aurélien Nicosia", subtitle = "Hi!", status = user_status,
      image = "moi.png"
    )
    
    # parse URL for userInfo
    if ( "user" %in% names(query) ) {
      
      # message("login as user: ", query[["user"]], "\n")
      
      if (query[["user"]] == "yg") {
        
        head_user <- dashboardUser(
          name = "Aurélien Nicosia",
          image = "moi.png",
          description = "Statistician",
          sub_description = "Member since Aug. 2015",
          stat1 = "10 Posts",
          stat2 = "10 Followers",
          stat3 = "10 Following"
        )
        
        side_user <- sidebarUserPanel(
          name = "Aurélien Nicosia", subtitle = "Hello!", status = user_status,
          image = "moi.png"
        )
        
      } 
      
    }
    
    return( list(head_user = head_user, side_user = side_user) )
    
  })
  
  output$user <- ygdashboard::renderUser({ create_userInfo() %$% head_user })
  
  output$dynamicSidebarUserPanel <- renderMenu({ create_userInfo() %$% side_user })
  
  
  #- create siderbarMenu menuSegment dynamically on the server side
  output$dynamicSidebarLabel <- renderMenu({ menuSegment(text="LABELS") })
  
  
  #- create carouselActiveItem reponses to carousel slide
  output$carouselActiveItem <- renderText({ paste0("You're at Carousel #", input$carouselExample) })
  
  
  
  # dropdown : iris clustering example ----
  selectedData <- reactive({
    iris[, c(input$xcol, input$ycol)]
  })
  
  Clusters <- reactive({
    kmeans(selectedData(), input$clusters)
  })
  
  output$plotkmeans2 <- renderPlot({
    palette(c("#E41A1C", "#377EB8", "#4DAF4A", "#984EA3",
              "#FF7F00", "#FFFF33", "#A65628", "#F781BF", "#999999"))
    
    par(mar = c(5.1, 4.1, 0, 1))
    plot(selectedData(),
         col = Clusters()$cluster,
         pch = 20, cex = 3)
    points(Clusters()$centers, pch = 4, cex = 4, lwd = 4)
  })
  
  
  
  # sweetalert ----
  observeEvent(input$success, {
    sendSweetAlert(
      messageId = "successmessage", title = "Success !!", text = "All in order", type = "success"
    )
  })
  
  observeEvent(input$error, {
    sendSweetAlert(
      messageId = "errormessage", title = "Error...", text = "Oups !", type = "error"
    )
  })
  
  observeEvent(input$info, {
    sendSweetAlert(
      messageId = "infomessage", title = "Information", text = "Something helpful", type = "info"
    )
  })
  
  observeEvent(input$tags, {
    sendSweetAlert(
      messageId = "tagsmessage", title = "HTLM tags",
      text = "normal <b>bold</b> <span style='color: steelblue;'>color</span> <h1>h1</h1>", html = TRUE, type = NULL
    )
  })
  
  observeEvent(input$warning, {
    sendSweetAlert(
      messageId = "warningmessage", title = "Warning !!!",
      text = NULL, type = "warning"
    )
  })
  
  
  
  
   output$dataTable2 <- DT::renderDataTable({
     iris2 = iris[c(1:10, 51:60, 101:110), ]
     DT::datatable(iris2, filter = 'top', options = list(
       pageLength = 5, autoWidth = TRUE
     ))
     
   })
   
   output$plot <- renderPlot({
     
     p <- ggplot(mpg, aes(displ, hwy, colour = class))+ geom_point()+ geom_smooth()
     p
     
     
   })
   
   output$plotPlotly <- renderPlotly({
     p <- ggplot(mpg, aes(displ, hwy, colour = class))+ geom_point()+ geom_smooth()
     p
     ggplotly(p)
     
   })
   
   output$print <- renderPrint({
     
     summary(lm(displ ~ hwy + class, data = mpg))
     
   })
   
  # 
  
   selectedDataReg <- reactive({
     return(iris[, c(input$ycolReg, input$xcolReg)])
   })
   
   regre <- reactive({
     formula.x <- paste((input$xcolReg),  collapse = '+')
     formula.reg <- paste0(input$ycolReg,"~" ,formula.x)
     return(lm( formula.reg, data = selectedDataReg() ))
   })
   
   output$reg <- renderPrint({
     
     summary(regre())
   }
   )
   
   
   output$report <- downloadHandler(
     
     filename = "rapport.pdf",
     content = function(file) {
       
       tempReport <- file.path(tempdir(), "rapport.Rmd")
       file.copy("rapport.Rmd", tempReport, overwrite = TRUE)
       
       
       params <- list(reg = regre(), title = input$title)
       
       
       rmarkdown::render(tempReport, output_file = file,
                         params = params,
                         envir = new.env(parent = globalenv())
       )
     }
   )
   
   observe({
     if(!is.null(input$title) ) {
       output$rep = renderUI({
         downloadButton("report", "Generate report")
       })
       
     }
   })
   
   adres <- reactive({return(input$adresse)})
   
   output$gvisCrunsh <- renderGvis({
     if (is.null(input$adresse ) | input$adresse ==  " ") return(NULL) 
     df <- data.frame(
       adresses = c(adres()),
       tip = c(" ")
     )
     mymap1 <- gvisMap(df,
                       locationvar = "adresses",
                       tipvar = "tip",
                       options=list(showTip=TRUE, 
                                    showLine=TRUE, 
                                    enableScrollWheel=TRUE,
                                    mapType='terrain', zoomLevel= 12, 
                                    useMapTypeControl=TRUE, "viewer"=NULL))
     return(mymap1)
     
   })
   
   
   #- create carouselActiveItem reponses to carousel slide
   output$carouselActiveItem <- renderText({ paste0("You're at Carousel #", input$carouselExample) })
   
   x.ng <- reactive({
     ng <- ngram(input$searchButton2, year_start = input$daterange[1], 
                 year_end = input$daterange[2], count = TRUE, corpus = input$checkbox, 
                 smoothing = 0)
     
   })
   x.etall <- reactive({
     
     ngram("et al", year_start = input$daterange[1], year_end = input$daterange[2], 
           count = TRUE, corpus = input$checkbox, smoothing = 0)
   })
   x.ofthe <- reactive({
     ngram("of the", year_start = input$daterange[1], year_end = input$daterange[2], 
           count = TRUE, corpus = input$checkbox, smoothing = 0)
   })
   x.the <- reactive({
     ngram("the", year_start = input$daterange[1], year_end = input$daterange[2], 
           count = TRUE, corpus = input$checkbox, smoothing = 0)
   })
   x <- reactive({
     df = data.frame(p.t = x.ng()$Count/x.the()$Count, q.t = x.etall()$Count/x.ofthe()$Count, 
                     time = x.ng()$Year)
   })
   
   x.final <- reactive({
     fit = gls(p.t ~ time * q.t, data = x(), corr = corAR1(form = ~1))
     
     
     
     # ## simple examples using gamm as alternative to gam
     beta <- coef(fit)
     beta.trans <- c(beta[3] + beta[1], beta[4] + beta[2], 
                     beta[1], beta[2])
     p.t_q.t <- pmax((beta.trans[1] + beta.trans[2] * x()$time) * 
                       x()$q.t, 0)
     p.t_Nq.t <- pmax((beta.trans[3] + beta.trans[4] * x()$time) * 
                        (1 - x()$q.t), 0)
     prop = c(p.t_q.t, p.t_Nq.t, x()$p.t)
     corpus = c(rep("Scientific literature", length(p.t_q.t)), 
                rep("Non scientific literature", length(p.t_Nq.t)), 
                rep("Google Viewer", length(x()$p.t)))
     df2 <- data.frame(proportion = prop * 100, Trends = corpus, 
                       Year = x()$time)
     df2
     
   })
   
   plot.choice = reactive(input$plotChoice)
   
   output$plot.corrected <- renderPlotly({
     if (plot.choice() == "all") {
       df = x.final()
       title.choix <- "Google Viewer and corrected trend"
     }
     if (plot.choice() == "google") {
       df = subset(x.final(), Trends == "Google Viewer")
       title.choix <- "Google Viewer trend"
     }
     if (plot.choice() == "corrected") {
       df = subset(x.final(), Trends != "Google Viewer")
       title.choix <- "Corrected trend"
     }
     
     p2 <- ggplot(df, aes(x = Year, y = proportion, colour = Trends)) + 
       geom_line() + ggtitle(paste0(title.choix, " of ", 
                                    input$searchButton2, sep = " ")) + ylab("Proportion (%)")
     ggplotly(p2)
     
   })
   
   
   output$calcul.taille <- renderText({
     n1.alea <-qnorm((1-(1-input$niveau.confiance/100)/2))^2*(input$prop.erreur/100*(1-input$prop.erreur/100)/(input$marge.erreur/100)^2)
     n.alea <- (1+n1.alea)/(1+n1.alea/input$taille.pop)
     paste0("La taille d'echantillon prevu est de: ",round(n.alea,2))
   })
   output$calcul.marge <- renderText({
     d1.alea <-qnorm((1-(1-input$niveau.confiance2/100)/2))
     d.alea <- d1.alea*sqrt((1-input$taille.echan2/input$taille.pop2)*(input$prop.erreur2/100)*(1-input$prop.erreur2/100)/(input$taille.echan2-1))
     ifelse(input$taille.echan2 < input$taille.pop2, paste0( "La marge d'erreur est de: ",formatC(as.numeric(d.alea*100), format="f", digits=2, big.mark=","), '%'),
            "Attention: La taille de l'echantillon doit etre plus petite que celle de la population!")
   })
   # p <-reactive({
   #   if (input$k == 2) p <- c(input$p1, input$p2)/100
   #   if (input$k == 3) p <- c(input$p1, input$p2, input$p3)/100
   #   if (input$k == 4) p <- c(input$p1, input$p2, input$p3, input$p4)/100
   #   if (input$k == 5) p <- c(input$p1, input$p2, input$p3, input$p4, input$p5)/100
   #   p
   #   
   # })
   # 
   dat <-reactive({
     dat=data.frame(row.names = paste0(seq(input$k)))
     if (input$k == 2) dat$n <- c(input$n1k2, input$n2k2)
     if (input$k == 3) dat$n <- c(input$n1k3, input$n2k3, input$n3k3)
     if (input$k == 4) dat$n <- c(input$n1k4, input$n2k4, input$n3k4, input$n4k4)
     if (input$k == 5) dat$n <- c(input$n1k5, input$n2k5, input$n3k5, input$n4k5, input$n5k5)
     if (input$k == 2) dat$p <- c(input$p1k2, input$p2k2)/100
     if (input$k == 3) dat$p <- c(input$p1k3, input$p2k3, input$p3k3)/100
     if (input$k == 4) dat$p <- c(input$p1k4, input$p2k4, input$p3k4, input$p4k4)/100
     if (input$k == 5) dat$p <- c(input$p1k5, input$p2k5, input$p3k5, input$p4k5, input$p5k5)/100
     dat$Wh <- dat$n/input$taille.popS
     
     dat$WhPhQh <- dat$Wh*dat$p*(1-dat$p)
     
     dat$WhRacinePhQh <- dat$Wh*sqrt(dat$p*(1-dat$p))
     dat
   }) 
   
   datStratMarge <-reactive({
     dat=data.frame(row.names = paste0(seq(input$k2)))
     if (input$k2 == 2) dat$n <- c(input$n1mk2, input$n2mk2)
     if (input$k2 == 3) dat$n <- c(input$n1mk3, input$n2mk3, input$n3mk3)
     if (input$k2 == 4) dat$n <- c(input$n1mk4, input$n2mk4, input$n3mk4, input$n4mk4)
     if (input$k2 == 5) dat$n <- c(input$n1mk5, input$n2mk5, input$n3mk5, input$n4mk5, input$n5mk5)
     if (input$k2 == 2) dat$p <- c(input$p1mk2, input$p2mk2)/100
     if (input$k2 == 3) dat$p <- c(input$p1mk3, input$p2mk3, input$p3mk3)/100
     if (input$k2 == 4) dat$p <- c(input$p1mk4, input$p2mk4, input$p3mk4, input$p4mk4)/100
     if (input$k2 == 5) dat$p <- c(input$p1mk5, input$p2mk5, input$p3mk5, input$p4mk5, input$p5mk5)/100
     dat$Wh <- dat$n/input$taille.popS2
     
     dat$WhPhQh <- dat$Wh*dat$p*(1-dat$p)
     
     dat$WhRacinePhQh <- dat$Wh*sqrt(dat$p*(1-dat$p))
     dat
   }) 
   
   
   
   n.taille <- reactive({
     
     z <-qnorm((1-(1-input$niveau.confianceS/100)/2))
     n0 <-z^2*sum(dat()$WhRacinePhQh)^2
     n0<- n0/((input$marge.erreurS/100)^2+z^2*sum(dat()$WhPhQh)/input$taille.popS)
     n0
     
   })
   
   output$calcul.tailleStrate <- renderText({
     
     
     
     #paste0("La taille d'echantillon prevu est de: ",sum(dat()$n))
     ifelse(sum(dat()$n)==input$taille.popS,paste0("La taille d'echantillon prevu est de: ",round(n.taille(),2),"\n","arrondir la taille a l'entier le plus eleve."),
            paste0("La sommes totales des tailles d'echantillons des strates devrait valoir: ",input$taille.popS ))
   })
   
   output$nh <-renderTable({
     df <- data.frame(strate = paste0(seq(input$k)))
     row.names(df) <- NULL 
     df$nh <-   n.taille()*dat()$WhRacinePhQh/sum(dat()$WhRacinePhQh)
     #df$nh[input$k1+1] <- sum(df$nh[c(1:input$k)])
     #row.names(df)[input$k+1,] = 'Total'
     df[input$k+1,]= c(NA,sum(df$nh[c(1:input$k)]))
     row.names(df)[input$k+1] = 'Total'
     # row.names(df)[seq(input$k)]=rep('',input$k)
     df
     
   })
   output$nhMarge <-renderTable({
     df <- data.frame(strate = paste0(seq(input$k2)))
     row.names(df) <- NULL 
     df$nh <-   input$taille.echS2*datStratMarge()$WhRacinePhQh/sum(datStratMarge()$WhRacinePhQh)
     #df$nh[input$k2+1] <- sum(df$nh[c(1:input$k2)])
     # row.names(df)=c(paste0(seq(input$k2+1)), 'Total')
     df[input$k2+1,]= c(NA,sum(df$nh[c(1:input$k2)]))
     row.names(df)[input$k2+1] = 'Total'
     #row.names(df)[seq(input$k2)]=rep('',input$k2)
     df
     
   })
   
   
   output$calcul.margeStrate <- renderText({
     
     
     
     z <-qnorm((1-(1-input$niveau.confianceS2/100)/2))
     d <-sqrt(1/input$taille.echS2*z^2*((sum(datStratMarge()$WhRacinePhQh)^2-input$taille.echS2/input$taille.popS2*sum(datStratMarge()$WhPhQh))))
     
     ifelse(sum(datStratMarge()$n)==input$taille.popS2, paste0( "La marge d'erreur est de: ",formatC(as.numeric(d*100), format="f", digits=2, big.mark=","), '%'),
            paste0("La sommes totales des tailles d'echantillons des strates devrait valoir: ",input$taille.popS2 ))
   })
   
   
  
   
   # Initialize reactive values 
   values = reactiveValues()
   
   # Function to get file path of uploaded file
   filepath = reactive({
     file = input$datafile
     if(is.null(file)) return()
     return(file$datapath)
   })
   
   
   # If the uploaded file is Excel create a dropdown menu so the user can select the
   # treatment coloum
   
   observe({
     if(is.null(input$dynamicinput)) {
       if(input$inputformat == 'excel' & !is.null(filepath())) {
         possibleerror = try(values$workbook <- XLConnect::loadWorkbook(filepath()), silent = TRUE)
         if(class(possibleerror) == 'try-error') { seterror('excelloaderror'); return() }
         sheetNames = XLConnect::getSheets(values$workbook)
         output$worksheets = renderUI({
           selectInput(inputId = "dynamicinput", 
                       label = "Select Worksheet",
                       choices = c(sheetNames))    
         })
       }
     }
   })
   
   
   inputdat <- reactive({
     if(is.null(input$datafile) ) return()
     clearerror()
     # Load the relvant data depending on the file type. If the specified file type doesn't
     # match the loaded file throw an error.
     inputdata = switch(input$inputformat,
                        'excel' = {
                          if(is.null(input$dynamicinput)) return()
                          if(input$inputformat == 'excel' & input$dynamicinput == 'select') return()
                          tryCatch({ readWorksheet(values$workbook, sheet = input$dynamicinput, header = TRUE)
                          }, error = function(e) { seterror('excelreaderror'); return() })
                        },
                        'csv' = {
                          tryCatch({ read.csv(file = filepath(), header = TRUE, stringsAsFactors = FALSE)
                          }, error = function(e) { seterror('csvloaderror'); return() })
                        })
     # Take the data and get out the first 10 rows. If there is an error it's likely because
     # the specified worksheet or data column has no data. Tell the user this if an error occurs.
     values$inputdata = inputdata
     #possibleerror = try(inputdata <- inputdata[[input$datacol]], silent = TRUE)
     #if(class(possibleerror) == 'try-error') { seterror('subscripterror'); return() }
     inputdata =as.data.frame(inputdata)
     #names(inputdata)[1] = "short_url_preview" 
     
     return(inputdata)   
   })
   
   output$boxData <- renderUI({
     if(is.null(input$datafile) ) return()
     box(width = NULL, title ='Look of the data', status = 'danger',solidHeader = TRUE,collapsible = TRUE,collapsed = FALSE,
         div(style = 'overflow-x: scroll;',
             actionButton("tabBut", "View Table")
             
             
            ))
     
   })
   
   output$formula <- renderUI({
     if(is.null(input$datafile) ) return()
     box(width = NULL, title ='formula', solidHeader = TRUE,collapsible = TRUE,collapsed = FALSE, status = "warning",
         textInput("formula.reg","Formula:","y~."), 
       
         textInput("random.reg","Random:","~"))     
   })
   
   output$resultReg <- renderUI({
     if(is.null(input$datafile) ) return()
   tabBox(
     title = "Mixed regression result",
     # The id lets us use input$tabset1 on the server to find the current tab
     id = "tabset1", height = "250px",
     tabPanel("Mixed regression model", 
              verbatimTextOutput("regression")),
     tabPanel( "Goodness of fit", 
              plotOutput("goodnessOfFit"))
   )
   })
   
   
   fit  <- reactive({
     ifelse( (is.null(input$datafile) ||is.null(input$formula.reg) || is.null(input$random.reg) ),
             return(NULL),
             return(lme.SCS(fixed = as.formula(input$formula.reg),random = as.formula(input$random.reg), data = inputdat())))
   })
   
   fit.error <- reactive({
     ifelse( (is.null(input$datafile) ||is.null(input$formula.reg) || is.null(input$random.reg) ),
             return(NULL),
             return(class(try(lme(fixed = as.formula(input$formula.reg),
                                  random = as.formula(input$random.reg), 
                                  data = inputdat())))))
     
     
     
   })
   
   output$regression <- renderPrint({
     if(is.null(input$datafile) ||is.null(input$formula.reg) || is.null(input$random.reg) || fit.error() == "try-error")
       return("There is something wrong in your formulas");
     print.lme.SCS(fit())
     
     
     
   })
   
   output$goodnessOfFit <- renderPlot({
     if(is.null(input$datafile) ||is.null(input$formula.reg) || length(input$formula.reg)==0 || fit.error() == "try-error")
       return(NULL);
     plot.lme.SCS(fit())    
     
   })
   
   
   
   
   observeEvent(input$tabBut,{

       toggleModal(session, modalId = "modalExample", toggle = "open")
   })
   
   
   output$inputdata =renderDataTable({
     
     return(inputdat())
   }, options = list(lengthMenu = c(5, 20,50), pageLength = 5, iDisplayLength = 5)
   )
   
   seterror = function(error) {
     errormessage = switch(error,
                           'excelloaderror' =  'Error: There was an error loading the file. 
                          Are you sure it is an Excel file? Try changing
                          your selection to CSV.',
                           'excelreaderror' =  'Error: The workbook loaded, but there was
                          an error reading the specified worksheet',
                           'csvloaderror'   =  'Error: There was an error loading the file. 
                          Are you sure it is a csv file?',
                           'fullurlserror'  =  'Error: There was a problem getting the full URLs.
                          Are you sure you selected the correct data column?',
                           'subscripterror' =  'Error: There does not seem to be any data there.',
                           'nodataerror'    =  'Error: Did you forget to upload data?')
     
     output$errortext = renderUI({
       tags$div(class = "errortext", checked = NA, 
                tags$p(errormessage))
     })
   }
   
   # Define a function to clear error messages.
   clearerror = function() {
     output$errortext = renderUI({
       p('')
     })
   }  
   
   mypdf1_list <- reactive({
     
     
     withProgress({
       
       if(nchar(input$link)>0){
         setProgress(message = "Downloading Document...")
         
         
         
         address=unlist(strsplit(input$link,","))
         
         
         pdfs=list()
         
         for(i in 1:length(address)){
           pdfs[[i]]= pdf_text(str_trim(address[i]))
         }
         
         pdfs
         
       }else(return(NULL))
       
     })
     
   })
   
   
   
   
   
   mypdf2_list<-reactive({
     
     inFile <- input$file1
     
     if (is.null(inFile)){
       return(NULL)
     }else{
       
       withProgress({
         setProgress(message = "Extracting Text...")
         
         lst=list()
         for(i in 1:length(inFile[,1])){
           lst[[i]] <- pdf_text(inFile[[i, 'datapath']])
         }
         
         lst
         
       })
     }
     
   })
   
   
   
   
   
   documents<-reactive({
     
     
     inFile <- input$file1
     
     #if (is.null(inFile))
     #return(NULL)
     
     c(unlist(strsplit(input$link,",")),inFile$name)
     
   })
   
   
   
   
   
   
   mymatrix<-reactive({
     
     
     withProgress({
       setProgress(message = "Processing corpus...")
       
       txt=c(unlist(mypdf1_list()), unlist(mypdf2_list()))
       
       
       if(is.null(txt))
         
         return(NULL)
       
       # Create corpus
       corpus=Corpus(VectorSource(txt))
       # Convert to lower-case
       corpus=tm_map(corpus,tolower)
       #corpus = tm_map(corpus, PlainTextDocument)
       corpus = tm_map(corpus, removePunctuation)
       
       # Remove stopwords
       corpus=tm_map(corpus,function(x) removeWords(x,stopwords("french")))
      # corpus <-  iconv(corpus, to = "utf-8", sub="")

       
       
       library(SnowballC)
       
       
       frequencies = DocumentTermMatrix(corpus, 
                                        control = list(removePunctuation = TRUE, 
                                                       stopwords =  TRUE, 
                                                       removeNumbers = TRUE, tolower = TRUE))
       # sparse = removeSparseTerms(frequencies,0.9)
       #sparse =as.matrix(sparse)
       
       sparse =as.matrix(frequencies)
       sparse=apply(sparse,2,sum)
       sparse=sparse[order(sparse,decreasing = T)]
       
       Term=names(sparse)
       Frequency=as.vector(sparse)
       
       sparse=as.data.frame(list(Term=Term,Frequency=Frequency))
       sparse$Term = stri_trans_totitle(sparse$Term) 
       sparse
       
     })
   })
   
   
   
   
   output$DataTable <-DT::renderDataTable(
     
     withProgress({
       setProgress(message = "Preparing Table...")
       datatable(
         mydataTable(), filter = 'top',  
         options = list(pageLength = 5, autoWidth = TRUE),
         rownames= FALSE
         
       )
     })
   )
   
   
   mydataTable<-reactive({
     
     withProgress({
       setProgress(message = "Computing...")
       if(is.null(mymatrix()))
         return(NULL)
       
       pdfs=c(mypdf1_list(), mypdf2_list())
       
       
       
       if(length(pdfs)>0){
         
         documents=documents()
         
         mydata=data.frame()
         
         for(i in 1:length(pdfs)){
           
           txt = pdfs[[i]]
           
           # Create corpus
           corpus=Corpus(VectorSource(txt))
           # Convert to lower-case
           corpus=tm_map(corpus,tolower)
          # corpus = tm_map(corpus, PlainTextDocument)
           corpus = tm_map(corpus, removePunctuation)
           
           # Remove stopwords
           corpus=tm_map(corpus,function(x) removeWords(x,stopwords("english")))
           
           frequencies = DocumentTermMatrix(corpus)
           #sparse = removeSparseTerms(frequencies,1)
           sparse =as.matrix(frequencies)
           sparse=apply(sparse,2,sum)
           sparse=sparse[order(sparse,decreasing = T)]
           
           Term=names(sparse)
           Frequency=as.vector(sparse)
           
           sparse=as.data.frame(list(Term=Term,Frequency=Frequency))
           sparse$Term = stri_trans_totitle(sparse$Term) 
           sparse$Document=documents[i]
           mydata=rbind(mydata,sparse)
           
         }
         
         mydata = mydata%>%mutate(Term = factor(Term,levels = Term[order(Frequency,decreasing =T)]))
         
         if(nrow(mydata)>7000){
           head(mydata,7000)
         }else{mydata}
         
       }
     })
   })
   
   
   
   output$wordcloud <- renderPlot({
     
     if(is.null(mymatrix()))
       return(NULL)
     
     sparse=mymatrix()
     
     pal2 <- brewer.pal(8,"Dark2")
     
     wordcloud(sparse$Term,sparse$Frequency, min.freq=input$freq, max.words=input$max,
               random.order=FALSE,scale=c(4,0.5),
               rot.per=0.35, use.r.layout=FALSE, colors=pal2)
     
     
     
     
     
     if(input$for_each==TRUE){
       
       
       if(is.null(mymatrix()))
         return(NULL)
       
       pdfs=c(mypdf1_list(), mypdf2_list())
       
       
       
       if(length(pdfs)>0){
         
         
         
         
         for(i in 1:length(pdfs)){
           
           txt = pdfs[[i]]
           
           # Create corpus
           corpus=Corpus(VectorSource(txt))
           # Convert to lower-case
           corpus=tm_map(corpus,tolower)
           #corpus = tm_map(corpus, PlainTextDocument)
           corpus = tm_map(corpus, removePunctuation)
           
           # Remove stopwords
           corpus=tm_map(corpus,function(x) removeWords(x,stopwords("english")))
           
           frequencies = DocumentTermMatrix(corpus)
           #sparse = removeSparseTerms(frequencies,1)
           sparse =as.matrix(frequencies)
           sparse=apply(sparse,2,sum)
           sparse=sparse[order(sparse,decreasing = T)]
           
           Term=names(sparse)
           Frequency=as.vector(sparse)
           
           sparse=as.data.frame(list(Term=Term,Frequency=Frequency))
           sparse$Term = stri_trans_totitle(sparse$Term) 
           
           
           pal2 <- brewer.pal(8,"Dark2")
           
           documents=documents()
           
           x11(title = documents[i])
           
           
           wordcloud(sparse$Term,sparse$Frequency, min.freq=input$freq, max.words=input$max,
                     random.order=FALSE,scale=c(4,0.5),
                     rot.per=0.35, use.r.layout=FALSE, colors=pal2)
           
         }
       }
     }
     
     
   })
   
   
   toshow<-reactive({
     input$show
   })
   
   
   output$myplot <- renderPlotly({
     
     if(is.null(mymatrix()))
       return(NULL)
     
     maximum =toshow()
     
     sparse=mymatrix()
     sparse=sparse[1:maximum,]
     
     q=sparse%>%mutate(Term = factor(Term,levels = Term[order(Frequency,decreasing =F)]))%>%
       ggplot(aes(x=Term,y=Frequency))+geom_bar(stat='identity',color='#c2c2a3',fill='#b35900')+
       xlab("")+ggtitle('Most frequent words')+theme(plot.title = element_text(size = 16,colour="blue"))+
       coord_flip()# +theme(axis.text.x = element_text(angle=-90))
     
     
     
     p <- ggplotly(q + ylab(" ") + xlab(" "))
     x <- list(
       title = "Frequency"
     )
     y <- list(
       title = ""
     )
     p %>% layout(xaxis = x, yaxis = y)
     
     
     
     
   })
   
   
   
   mysearch<-reactive({
     
     input$search
     isolate(
       stri_trans_totitle(input$searchText)
     )
     
   })
   
   
   
   SearchMatrix<-reactive({
     
     if(is.null(mysearch()))
       return(NULL)
     
     if(is.null(mymatrix()))
       return(NULL)
     
     pdfs=c(mypdf1_list(), mypdf2_list())
     
     
     if(length(pdfs)>0){
       
       
       
       mm=data.frame()
       
       for(i in 1:length(pdfs)){
         
         txt = pdfs[[i]]
         
         # Create corpus
         corpus=Corpus(VectorSource(txt))
         # Convert to lower-case
         corpus=tm_map(corpus,tolower)
        # corpus = tm_map(corpus, PlainTextDocument)
         corpus = tm_map(corpus, removePunctuation)
         
         # Remove stopwords
         corpus=tm_map(corpus,function(x) removeWords(x,stopwords("english")))
         
         frequencies = DocumentTermMatrix(corpus)
         #sparse = removeSparseTerms(frequencies,1)
         sparse =as.matrix(frequencies)
         sparse=apply(sparse,2,sum)
         sparse=sparse[order(sparse,decreasing = T)]
         
         Term=names(sparse)
         Frequency=as.vector(sparse)
         
         sparse=as.data.frame(list(Term=Term,Frequency=Frequency))
         sparse$Term = stri_trans_totitle(sparse$Term) 
         
         if(stri_trans_totitle(mysearch())%in%sparse$Term==TRUE){
           total= filter(sparse,Term==stri_trans_totitle(mysearch()))$Frequency
         }else{total=0}
         
         mm=rbind(mm,total)
         
       }
       
       Documents=documents()
       names(mm)=c('Frequency')
       
       mm=cbind(Documents,mm)
       mm
     }
     
   })
   
   
   
   output$searched<-renderPlotly({
     
     if(is.null(SearchMatrix()))
       return(NULL)
     
     
     if(is.na(SearchMatrix()))
       return(NULL)
     
     if(nchar(SearchMatrix())==0)
       return(NULL)
     
     mm=SearchMatrix()
     
     q=mm%>%mutate(Documents = factor(Documents,levels = Documents[order(Frequency,decreasing =T)]))%>%
       ggplot(aes(x=Documents,y=Frequency))+geom_bar(stat='identity',color='#c2c2a3',fill='#999966',width=.5)+
       xlab("")+ggtitle('Search Term Frequency by Document')+ylab('')+
       theme(axis.text.x = element_text(angle=-20))+
       theme(plot.title = element_text(size = 16,colour="blue"))+
       theme(axis.text.x = element_text(colour="#4d0000",size=12))
     
     
     p = ggplotly(q)
     
     
     p
     
     
   })
   
   
   output$minfreq = renderUI({
     
     if(is.null(mymatrix()))
       return(NULL)
     sliderInput("freq",
                 em("Minimum Frequency:",style="color:black;font-size:100%"),
                 min = 1,  max = 50, value = 15)
   })
   
   
   output$numwords = renderUI({
     
     if(is.null(mymatrix()))
       return(NULL)
     
     sliderInput("show",
                 em("Number of Words to Display:",style="color:Blue;font-size:100%"),
                 min = 5,  max = 50, value = 25)
   })
   
   
   output$maxwords = renderUI({
     
     if(is.null(mymatrix()))
       return(NULL)
     sliderInput("max",
                 em("Maximum Number of Words:",style="color:black;font-size:100%"),
                 min = 1,  max = 300,  value = 200)
   })
   
   
   output$forEach = renderUI({
     
     if(is.null(mymatrix()))
       return(NULL)
     checkboxInput("for_each", label = p("Create Word Cloud for Each Document",style="color:#ff0000;font-size:120%" ))
   })
   
   
   
   
   output$forsearch = renderUI({
     
     if(is.null(mymatrix()))
       return(NULL)
     sidebarSearchForm(label = "Search...", textId="searchText", "searchButton")
   })
   
   
   output$text= renderUI({
     
     if(!is.null(mymatrix())){
       
       
       p("Search a word and you will see a bar graph of its frequency across all documents",
         style="text-align:center;color:#990099;font-size:110%")
     }
   })
   
   
   
   output$searchbutton = renderUI({
     
     if(is.null(mymatrix()))
       return(NULL)
     actionButton("search", "Search")
   })
   
   output$pdfviewer <- renderText({
     return(paste('<iframe style="height:800px; width:100%" src="', "PDF/", gsub(" ",'+',"pp.pdf"), '"></iframe>', sep = ""))
   })
  
   

   
   
  })
